#include <stdio.h>
#include <stdlib.h>

#define MAXDIM 4
#define MAXSTRLEN 100
#define MAXCHAR1 20
#define MAXCHAR2 50

/* definizione del tipo GLOBALE record di nome "prodotto" */
typedef struct product
   {
   char codice[MAXCHAR1];
   char descrizione[MAXCHAR2];
   int giacenza;
   float prezzo;      
   } prodotto;



int main(int argc, char *argv[])
{
/* numero intero di esempio */ 
int n;
/* carattere di esempio */
char car;
/* vettore di esempio opportunamente inizializzato */
int vett[MAXDIM]={3,5,2,7};
/* record di esempio opportunamente inizializzato */
prodotto prod = {"RXE432", "Antenna parabolica",45, 11.50}; 

/* definizione delle variabili di tipo puntatore necessarie */
int* p_n;
char* p_car;
prodotto* p_prod=NULL;

/* variabili per gestire la comunicazione dei messaggi all'utente */
int i;
char s[MAXSTRLEN], s1[MAXSTRLEN];


/* inizializzazione stringhe di segnalazione per vettore*/
strcpy(s," Uso nel ciclo di visualizzazione dell'istruzione : printf(\"%d\",vett[i])"); 
strcpy(s1," Uso nel ciclo di visualizzazione dell'istruzione : printf(\"%d\",*(vett+i))");


system("CLS");
printf("\nQuesto programmma illustra il significato delle variabili di tipo puntatore");
printf("\nInserisci un numero intero a tuo piacere : ");
fflush(stdin);
scanf("%d",&n);

printf("\nOra colleghiamo il puntatore p_n alla variabile intera n mediante\n");
printf("l'istruzione  p_n = &n \n");
/* collegamento del puntatore ad intero p_n alla variabile intera n */
p_n = &n;
printf("\nPertanto per visualizzare e/o valorizzare il valore della variabile \n");
printf("possiamo usare da ora in poi indifferentemente sia n oppure *p_n \n");
printf("\nInfatti:");
printf("\nValore di n = %d *** Valore di *p_n = %d", n, *p_n);
printf("\nIndirizzo della variabile n = %x *** Valore della variabile p_n = %x\n", &n, p_n);
printf("\nQuindi la variabile puntatore, opportunamente valorizzata, contiene l'indirizzo");
printf(" in esadecimale della cella (locazione) di memoria in cui e' memorizzato il dato\n\n");
system("PAUSE");

system("CLS");
printf("\nLa stessa cosa vale per tutti gli altri tipi di dato semplice (Es. CHAR)");
printf("\nInserisci un carattere a tuo piacere : ");
fflush(stdin);
scanf("%c",&car);

printf("\nOra colleghiamo il puntatore p_car alla variabile carattere car mediante\n");
printf("l'istruzione  p_car = &car \n");
/* collegamento del puntatore ad intero p_car alla variabile carattere car */
p_car = &car;
printf("\nPertanto per visualizzare e/o valorizzare il valore della variabile \n");
printf("possiamo usare da ora in poi indifferentemente sia car oppure *p_car \n");
printf("\nInfatti:");
printf("\nValore di car = %c *** Valore di *p_car = %c", car, *p_car);
printf("\nIndirizzo della variabile car = %x *** Valore della variabile p_car = %x\n", &car, p_car);
printf("Quindi la variabile puntatore, opportunamente valorizzata, contiene l'indirizzo");
printf(" in esadecimale della cella (locazione) di memoria in cui e' memorizzato il dato\n\n");
system("PAUSE");

system("CLS");
printf("\nPer il tipo dato strutturato vettore succede una cosa molto interessante\n");
printf("\nAbbiamo costruito come esempio un vettore monodimensionale contenente 4 interi\n");
printf("\n\t\tvett[%d] = [ 3 5 2 7 ]\n",MAXDIM);

printf("\nIn questo caso il nome del vettore - vett - rappresenta gia' un\n");
printf("puntatore al primo elemento dell'array ossia all'elemento vett[0]\n");
printf("Infatti:\n\t\tValore di vett[0] = %d *** Valore di *vett = *(vett+0) = %d \n\n", vett[0], *vett);

/* visualizzazione del vettore utilizzando l'accesso diretto attraverso un indice */
printf("Per questo sara' possibile visualizzare tutti gli elementi dell'array:\n");
printf(" a) utilizzando il \"classico\" accesso diretto mediante un indice\n");
printf("%s", s);
printf("\n\t\tvett[%d] = [ ",MAXDIM);
for (i=0; i<MAXDIM; i++)
   {
        
   printf("%d ",vett[i]);
   }       
printf("]\n\n");

/* visualizzazione del vettore utilizzando l'aritmetica dei puntatori */
printf(" b) utilizzando i puntatori e la loro \"aritmetica\"\n");
printf("%s", s1);
printf("\n\t\tvett[%d] = [ ",MAXDIM);
for (i=0; i<MAXDIM; i++)
   {
   printf("%d ",*(vett+i));
   }       
printf("]\n\n");
system("PAUSE");

system("CLS");
printf("\nAnche con il tipo dato strutturato record e' possibile utilizzare i puntatori\n");
printf("\nOra colleghiamo il puntatore p_prod al record prod di tipo prodotto mediante\n");
printf("l'istruzione  p_prod = &prod \n");
/* collegamento del puntatore ad intero p_n alla variabile intera n */
p_prod = &prod;
printf("\nPertanto per visualizzare e/o valorizzare il valore della variabile \n");
printf("possiamo usare da ora in poi indifferentemente sia prod oppure *p_prod \n");

printf("\nOra e' possibile visualizzare il record che abbiamo costruito come esempio:");
printf("\nutilizzando: \n");
printf("\n a) il classico accesso a ciascun campo basato sull'istruzione\n");
printf("\tprod.<nome_campo> \n");
printf("\nCodice = %s", prod.codice);
printf("\nDescrizione = %s", prod.descrizione);
printf("\nGiacenza = %d", prod.giacenza);
printf("\nPrezzo = %.2f\n", prod.prezzo);

printf("\n b) l'accesso a ciascun campo sfruttando il puntatore basato sull'istruzione\n");
printf("\tp_prod -> <nome_campo> \n");
printf("\nCodice = %s", p_prod->codice);
printf("\nDescrizione = %s", p_prod->descrizione);
printf("\nGiacenza = %d", p_prod->giacenza);
printf("\nPrezzo = %.2f\n\n", p_prod->prezzo);
system("PAUSE");
	
return 0;
}
